<?php
/**
* Member Care System for Joomla
*
* @package MCS
* @author Mohamed Abdelaziz
* @copyright Mohamed Abdelaziz <zizo@joomlareem.com>
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );
global $mosConfig_lang, $mosConfig_absolute_path;

require_once( $mainframe->getPath( 'admin_html' ) );
//require_once( $mainframe->getPath( 'class' ) );

if( !@include_once( $mosConfig_absolute_path ."/administrator/components/com_mcs/lang/$mosConfig_lang.php" ) ) {
	include_once( $mosConfig_absolute_path ."/administrator/components/com_mcs/lang/english.php" );
}

$cid = josGetArrayInts( 'cid' );

switch ($task) {
	// Inactive Members
	case 'inactive':
		showUsers( $option );
		break;
	case 'resend':
		resend( $id, $option );
		break;
	case 'remove':
		deleteUsers( $cid, $option );
		break;
	case 'resendA':
		resend( $cid, $option );
		break;
	case 'remindA':
		remindAll( $option, false );
		break;
	case 'remindAuto':
		remindAll($option);
		break;
	//Absent Members
	case 'absent':
		showAbsentUsers( $option );
		break;
	case 'invite':
		invite( $id, $option );
		break;
	case 'inviteA':
		invite( $cid, $option );
		break;

	// Configuration
	case 'config':
		showConfig( $option );
		break;
	case 'saveconfig':
		saveSettings( $option );
		break;
	case 'cancelconfig':
		cancelSettings( $option );
		break;

	default:
		break;
}

function showUsers( $option ) {
	global $database, $mainframe, $my, $acl, $mosConfig_list_limit;

	$limit 			= intval( $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit ) );
	$limitstart 	= intval( $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 ) );

	// 	Check for new users
 	syncUsers();
	$maxADays = getMcsParam('mcs_maxdays');
	$reminderDays = intval( $mainframe->getUserStateFromRequest( "reminderDays{$option}", 'reminderDays', 0) );
	$cb_installed = getmcsParam('cb_installed');

	$where 			= array();

	// exclude any child group id's for this user
	$pgids = $acl->get_group_children( $my->gid, 'ARO', 'RECURSE' );

	if (is_array( $pgids ) && count( $pgids ) > 0) {
		$where[] = "(a.gid NOT IN (" . implode( ',', $pgids ) . "))";
	}
	if ($cb_installed)
		$where[] = " cbactivation <> '' ";
	else
		$where[] = " activation <> '' ";
	if ($cb_installed)
		$query = "SELECT COUNT(a.id)"
		. "\n FROM #__comprofiler AS a";
	else
		$query = "SELECT COUNT(a.id)"
		. "\n FROM #__users AS a";
	if ($reminderDays){
		$query .= "\n INNER JOIN #__mcs AS m ON a.id=m.userid";
		$where[]= "DATE_SUB(CURDATE(),INTERVAL $reminderDays DAY) <= m.lastReminderDate";
	}


	$query .= ( count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : '' )
	;
	$database->setQuery( $query );
	$total = $database->loadResult();

	require_once( $GLOBALS['mosConfig_absolute_path'] . '/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit  );
	if ($cb_installed)
		$query = "SELECT a.*, m.reminders, m.lastReminderDate"
		. "\n FROM #__users AS a"
		."\n INNER JOIN #__comprofiler AS c ON a.id = c.id";
	else
		$query = "SELECT a.*,  m.reminders, m.lastReminderDate"
		. "\n FROM #__users AS a";

	$query .= "\n INNER JOIN #__mcs AS m ON a.id = m.userid";
	$query .= (count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "")
	//. "\n GROUP BY a.id"
	;
	$database->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $database->loadObjectList();

	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	HTML_mcs::showUsers( $rows, $pageNav,  $option, $reminderDays, $maxADays);
}

function showAbsentUsers( $option ) {
	global $database, $mainframe, $my, $acl, $mosConfig_list_limit;

	$limit 	= intval( $mainframe->getUserStateFromRequest( "viewlistlimit", 'limit', $mosConfig_list_limit ) );
	$limitstart = intval( $mainframe->getUserStateFromRequest( "view{$option}limitstart", 'limitstart', 0 ) );
	// Check for new users
 	syncUsers();
	$maxADays = getMcsParam('mcs_maxdays');
	$absentDays = intval( $mainframe->getUserStateFromRequest( "absentDays{$option}", 'absentDays', ($maxADays>1)?$maxADays:120) );
	$neverLoggedIn = intval($mainframe->getUserStateFromRequest( "neverLoggedIn{$option}", 'neverLoggedIn', 0));
	$operator = $mainframe->getUserStateFromRequest( "operators{$option}", 'operators', 0 );
	$orderby = mosGetParam($_REQUEST, 'orderby', 'absentDays');
	$sort = mosGetParam($_REQUEST, 'ordering', 'ASC');

	$oper = '';
	switch ($operator)
	{
	case 0:
		$oper = '<';
		break;
	case 1:
		$oper = '<=';
		break;
	case 2:
		$oper = '>';
		break;
	case 3:
		$oper = '>=';
		break;
	case 4:
		$oper = '=';
		break;
	default:
		break;
	}
	$cb_installed = getMcsParam('cb_installed');

	$where 			= array();

	// exclude any child group id's for this user
	$pgids = $acl->get_group_children( $my->gid, 'ARO', 'RECURSE' );

	if (is_array( $pgids ) && count( $pgids ) > 0) {
		$where[] = "(a.gid NOT IN (" . implode( ',', $pgids ) . "))";
	}
	if ($cb_installed)
		$where[] = " c.cbactivation = '' ";
	else
		$where[] = " a.activation = '' ";

	if($neverLoggedIn)
		$where[] = " (a.lastvisitDate < a.registerDate AND TO_DAYS(current_date) - TO_DAYS(a.registerDate)  $oper $absentDays )";
	else
		$where[] = " ((a.lastvisitDate >= a.registerDate AND TO_DAYS(current_date) - TO_DAYS(a.lastvisitDate) "
					. " $oper $absentDays ) OR (a.lastvisitDate < a.registerDate "
					. " AND TO_DAYS(current_date) - TO_DAYS(a.registerDate)  $oper $absentDays ))";
	if ($cb_installed)
		$query = "SELECT COUNT(a.id)"
		. "\n FROM #__users AS a "
		. "\n INNER JOIN #__comprofiler AS c  ON a.id = c.id";
	else
		$query = "SELECT COUNT(a.id)"
		. "\n FROM #__users AS a";

	$query .= ( count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : '' );
	$database->setQuery( $query );
	$total = $database->loadResult();

	require_once( $GLOBALS['mosConfig_absolute_path'] . '/administrator/includes/pageNavigation.php' );
	$pageNav = new mosPageNav( $total, $limitstart, $limit  );
	if ($cb_installed)
		$query = "SELECT a.*, m.invites, m.lastInviteDate, CASE a.lastvisitDate WHEN a.lastvisitDate IS NULL THEN TO_DAYS(current_date) - TO_DAYS(a.registerDate) ELSE TO_DAYS(current_date) - TO_DAYS(a.lastvisitDate) END AS absentDays , CASE a.lastvisitDate WHEN a.lastvisitDate IS NULL THEN 1 ELSE 0 END As neverLogIn "
		. "\n FROM #__users AS a"
		."\n INNER JOIN #__comprofiler AS c ON a.id = c.id";
	else
		$query = "SELECT a.*, m.invites, m.lastInviteDate, CASE a.lastvisitDate WHEN a.lastvisitDate IS NULL THEN TO_DAYS(current_date) - TO_DAYS(a.registerDate) ELSE TO_DAYS(current_date) - TO_DAYS(a.lastvisitDate) END AS absentDays , CASE a.lastvisitDate WHEN a.lastvisitDate IS NULL THEN 1 ELSE 0 END As neverLogIn "
		. "\n FROM #__users AS a";

	$query .= "\n INNER JOIN #__mcs AS m ON a.id = m.userid";
	$query .= (count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "");
	$query .= "ORDER BY $orderby $sort, a.id ASC";
	//echo $query;
	$database->setQuery( $query, $pageNav->limitstart, $pageNav->limit );
	$rows = $database->loadObjectList();

	if ($database->getErrorNum()) {
		echo $database->stderr();
		return false;
	}

	HTML_mcs::showAbsentUsers( $rows, $pageNav,  $option, $absentDays, $operator, $orderby, $sort,$maxADays, $neverLoggedIn);
}
/**
 * Resend the user activation link
 * @param int The user ID
 * @param string The URL option
 */
function resend( $cid=null, $option='mcs' ) {
	global $database, $my, $acl, $mainframe, $mosConfig_sitename, $mosConfig_live_site;
	global $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_useractivation;

	$cb_installed = getmcsParam('cb_installed');
	$emails_count = 0;
	$subject 	= getmcsParam('rae_subject');
	$subject 	= html_entity_decode($subject, ENT_QUOTES);
	$tags = array("[NAME]","[UNAME]","[SITENAME]","[LIVESITE]","[ALINK]","<br />");
	$tagsValues = array(" "," ",$mosConfig_sitename,$mosConfig_live_site," "," ");
	$row = '';
	// check if Global Config `mailfrom` and `fromname` values exist
	if ($mosConfig_mailfrom != '' && $mosConfig_fromname != '') {
		$adminName2 	= $mosConfig_fromname;
		$adminEmail2 	= $mosConfig_mailfrom;
	} else {
	// use email address and name of first superadmin for use in email sent to user
		$query = "SELECT name, email"
		. "\n FROM #__users"
		. "\n WHERE LOWER( usertype ) = 'superadministrator'"
		. "\n OR LOWER( usertype ) = 'super administrator'"
		;
		$database->setQuery( $query );
		$rows = $database->loadObjectList();
		$row2 			= $rows[0];

		$adminName2 	= $row2->name;
		$adminEmail2 	= $row2->email;
	}

	if ( is_array( $cid ) ) {
		if (count( $cid ) < 1) {
			mosRedirect( 'index2.php?option='. $option."&task=inactive", 'Please select a user' );
		}

		foreach( $cid as $cidA ) {
			if($cb_installed){
				$query = "SELECT a.*, c.cbactivation"
				. "\n FROM #__users AS a"
				."\n INNER JOIN #__comprofiler AS c ON a.id = c.id"
				."\n WHERE a.id=$cidA";
				$database->setQuery( $query );
				$database->loadObject($row);
			} else {
				$row = new mosUser( $database );
				$row->load( $cidA );
			}

			if ($mosConfig_useractivation == 1){
				if($cb_installed)
					$tagsValues[4] = $mosConfig_live_site."/index.php?option=com_comprofiler&task=confirm&confirmcode=".$row->cbactivation;
				else
					$tagsValues[4] = $mosConfig_live_site."/index.php?option=com_registration&task=activate&activation=".$row->activation;
			}
			$tagsValues[0] = $row->name;
			$tagsValues[1] = $row->username;
			$message = getmcsParam('rae_message');
			$message = str_replace($tags, $tagsValues, $message);
			$message = html_entity_decode($message, ENT_QUOTES);
			$subject 	= getmcsParam('rae_subject');
			$subject = str_replace($tags, $tagsValues, $subject);
			$subject 	= html_entity_decode($subject, ENT_QUOTES);
			// Send email to user
			mosMail($adminEmail2, $adminName2, $row->email, $subject, $message);
			updateReminders($row->id);
			$emails_count++;
		}
	} else {
		if($cb_installed){
				$query = "SELECT a.*, c.cbactivation"
				. "\n FROM #__users AS a"
				."\n INNER JOIN #__comprofiler AS c ON a.id = c.id"
				."\n WHERE a.id=$cid";
				$database->setQuery( $query );
				$database->loadObject($row);
		} else {
				$row = new mosUser( $database );
				$row->load( $cid );
		}

		if ($mosConfig_useractivation == 1){
				if($cb_installed)
					$tagsValues[4] = $mosConfig_live_site."/index.php?option=com_comprofiler&task=confirm&confirmcode=".$row->cbactivation;
				else
					$tagsValues[4] = $mosConfig_live_site."/index.php?option=com_registration&task=activate&activation=".$row->activation;
		}
		$tagsValues[0] = $row->name;
		$tagsValues[1] = $row->username;
		$message = getmcsParam('rae_message');
		$message = str_replace($tags, $tagsValues, $message);
		$message = html_entity_decode($message, ENT_QUOTES);
		$subject 	= getmcsParam('rae_subject');
		$subject = str_replace($tags, $tagsValues, $subject);
		$subject 	= html_entity_decode($subject, ENT_QUOTES);
		// Send email to user
		mosMail($adminEmail2, $adminName2, $row->email, $subject, $message);
		updateReminders($row->id);
		$emails_count++;
	}
	mosRedirect( 'index2.php?option=mcs&task=inactive','There are '.$emails_count.' email(s) have been sent' );
}

/**
 * Invite Absent Members
 * @param int The user ID
 * @param string The URL option
 */
function invite( $cid=null, $option='mcs' ) {
	global $database, $my, $acl, $mainframe, $mosConfig_sitename, $mosConfig_live_site;
	global $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_useractivation;

	$cb_installed = getmcsParam('cb_installed');
	$emails_count = 0;
	$subject 	= getmcsParam('iam_subject');
	$subject 	= html_entity_decode($subject, ENT_QUOTES);
	$tags = array("[NAME]","[UNAME]","[SITENAME]","[LIVESITE]","[ADAYS]","<br />");
	$tagsValues = array(" "," ",$mosConfig_sitename,$mosConfig_live_site," "," ");
	$row = '';
	// check if Global Config `mailfrom` and `fromname` values exist
	if ($mosConfig_mailfrom != '' && $mosConfig_fromname != '') {
		$adminName2 	= $mosConfig_fromname;
		$adminEmail2 	= $mosConfig_mailfrom;
	} else {
	// use email address and name of first superadmin for use in email sent to user
		$query = "SELECT name, email"
		. "\n FROM #__users"
		. "\n WHERE LOWER( usertype ) = 'superadministrator'"
		. "\n OR LOWER( usertype ) = 'super administrator'"
		;
		$database->setQuery( $query );
		$rows = $database->loadObjectList();
		$row2 			= $rows[0];

		$adminName2 	= $row2->name;
		$adminEmail2 	= $row2->email;
	}

	if ( is_array( $cid ) ) {
		if (count( $cid ) < 1) {
			mosRedirect( 'index2.php?option='. $option."&task=absent", 'Please select a user' );
		}

		foreach( $cid as $cidA ) {
			if($cb_installed){
				$query = "SELECT a.*, c.cbactivation"
				. "\n FROM #__users AS a"
				."\n INNER JOIN #__comprofiler AS c ON a.id = c.id"
				."\n WHERE a.id=$cidA";
				$database->setQuery( $query );
				$database->loadObject($row);
			} else {
				$row = new mosUser( $database );
				$row->load( $cidA );
			}

			$sinceDate = !($row->lastvisitDate)? $row->registerDate : $row->lastvisitDate;
			$tagsValues[4] =((int)(((time()-strtotime($sinceDate))/86400))) + 1;
			//$tagsValues[4] = $row->absentDays;
			$tagsValues[0] = $row->name;
			$tagsValues[1] = $row->username;
			$message = getmcsParam('iam_message');
			$message = str_replace($tags, $tagsValues, $message);
			$message = html_entity_decode($message, ENT_QUOTES);
			$subject = getmcsParam('rae_subject');
			$subject = str_replace($tags, $tagsValues, $subject);
			$subject = html_entity_decode($subject, ENT_QUOTES);
			// Send email to user
			mosMail($adminEmail2, $adminName2, $row->email, $subject, $message);
			updateInvites($row->id);
			$emails_count++;
		}
	} else {
		if($cb_installed){
				$query = "SELECT a.*, c.cbactivation"
				. "\n FROM #__users AS a"
				."\n INNER JOIN #__comprofiler AS c ON a.id = c.id"
				."\n WHERE a.id=$cid";
				$database->setQuery( $query );
				$database->loadObject($row);
		} else {
				$row = new mosUser( $database );
				$row->load( $cid );
		}

		$sinceDate = !($row->lastvisitDate)? $row->registerDate : $row->lastvisitDate;
		$tagsValues[4] =((int)(((time()-strtotime($sinceDate))/86400))) + 1;
		//$tagsValues[4] = $row->absentDays;
		$tagsValues[0] = $row->name;
		$tagsValues[1] = $row->username;
		$message = getmcsParam('iam_message');
		$message = str_replace($tags, $tagsValues, $message);
		$message = html_entity_decode($message, ENT_QUOTES);
		$subject = getmcsParam('rae_subject');
		$subject = str_replace($tags, $tagsValues, $subject);
		$subject = html_entity_decode($subject, ENT_QUOTES);
		// Send email to user
		mosMail($adminEmail2, $adminName2, $row->email, $subject, $message);
		updateInvites($row->id);
		$emails_count++;
	}
	mosRedirect( 'index2.php?option=mcs&task=absent','There are '.$emails_count.' email(s) have been sent' );
}

/*
 * This function will delete the selected users permenantly
 */
function deleteUsers($cid, $option){
	global $database, $acl, $my;

	if (count( $cid ) < 1) {
		echo "<script> alert('Select an item to delete'); window.history.go(-1);</script>\n";
		exit;
	}
	$cb_installed = getmcsParam('cb_installed');
	$query = "DELETE FROM #__users WHERE id IN(".implode(',',$cid).")";
	$database->setQuery($query);
	if (!$database->query()) {
				echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
	}
	if($cb_installed){
		$query = "DELETE FROM #__comprofiler WHERE user_id IN(".implode(',',$cid).")";
		$database->setQuery($query);
		if (!$database->query()) {
				echo "<script> alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
		}
	}
	mosRedirect( 'index2.php?option=com_mcs&task=inactive', _MSG_DELETE_SUCCESSFULL );
}

function showConfig( $option='com_mcs') {
	global $database, $mainframe, $mosConfig_list_limit;

	$query = "SELECT a.id
				FROM #__components AS a
				WHERE a.name = 'Member Care System' and a.parent=0";
	$database->setQuery( $query );
	$id = $database->loadResult();

	// load the row from the db table
	$row = new mosComponent( $database );
	$row->load( $id );

	// get params definitions
	$params = new mosParameters( $row->params, $mainframe->getPath( 'com_xml', $row->option ), 'component' );

	HTML_mcs::settings( $option, $params, $id );
}
function saveSettings( $option ) {
	global $database;

	$params = mosGetParam( $_POST, 'params', '' );
	if (is_array( $params )) {
		$txt = array();
		foreach ($params as $k=>$v) {
			$txt[] = "$k=$v";
		}
		if( is_callable(array('mosParameters', 'textareaHandling'))) {
			$_POST['params'] = mosParameters::textareaHandling( $txt );
		}
		else {

			$total = count( $txt );
			for( $i=0; $i < $total; $i++ ) {
				if ( strstr( $txt[$i], "\n" ) ) {
					$txt[$i] = str_replace( "\n", '<br />', $txt[$i] );
				}
			}
			$_POST['params'] = implode( "\n", $txt );

		}
	}

	$id = mosGetParam( $_POST, 'id' );
	$row = new mosComponent( $database );
	$row->load( $id );
	if (!$row->bind( $_POST )) {
		echo "<script type=\"text/javascript\"> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}

	if (!$row->check()) {
		echo "<script type=\"text/javascript\"> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}
	if (!$row->store()) {
		echo "<script type=\"text/javascript\"> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		exit();
	}

	$msg = 'Settings successfully Saved';
	mosRedirect( 'index2.php?option='. $option."&task=config", $msg );
}

/**
* Cancels editing and checks in the record
*/
function cancelSettings( $option='com_mcs'){
	mosRedirect( 'index2.php?option='.$option."&task=inactive" );
}


function getMcsParam($param_name){
	global $database, $mainframe;

	$query = "SELECT a.id
				FROM #__components AS a
				WHERE a.name = 'Member Care System' and a.parent=0";
	$database->setQuery( $query );
	$id = $database->loadResult();

	// load the row from the db table
	$row = new mosComponent( $database );
	$row->load( $id );

	// get params definitions
	$params = new mosParameters( $row->params, $mainframe->getPath( 'com_xml', $row->option ), 'component' );
	return ($params->get($param_name));
}

function updateReminders($id){
	global $database;
	$query = "UPDATE #__mcs"
			."\n SET reminders = reminders + 1, lastReminderDate = CURDATE()"
			."\n WHERE userid = $id";
	$database->setQuery($query);
	$database->query();
}

function updateInvites($id){
	global $database;
	$query = "UPDATE #__mcs"
			."\n SET invites = invites + 1, lastInviteDate = CURDATE()"
			."\n WHERE userid = $id";
	$database->setQuery($query);
	$database->query();
}
function syncUsers(){
	global $database;

	$query = "SELECT id FROM #__users"
			."\n WHERE id NOT IN (SELECT userid FROM #__mcs)";
	$database->setQuery($query);
	$newUsers = $database->loadResultArray();

	if(count($newUsers) > 0){
		foreach($newUsers as $user){
			$query = "INSERT INTO #__mcs(userid) VALUES($user)";
			$database->setQuery($query);
			if (!$database->query()) {
				echo "<script> alert('".$database->getErrorMsg()."'); </script>\n";
			}
		}
	}
}

function remindAll($option,$auto=true){
	global $database, $my, $acl, $mainframe, $mosConfig_sitename, $mosConfig_live_site;
	global $mosConfig_mailfrom, $mosConfig_fromname, $mosConfig_useractivation;

	$cb_installed = getmcsParam('cb_installed');
	$emails_count = 0;
	$subject 	= getmcsParam('rae_subject');
	$subject 	= html_entity_decode($subject, ENT_QUOTES);
	$tags = array("[NAME]","[UNAME]","[SITENAME]","[LIVESITE]","[ALINK]","<br />");
	$tagsValues = array(" "," ",$mosConfig_sitename,$mosConfig_live_site," "," ");
	//$row = '';
	// check if Global Config `mailfrom` and `fromname` values exist
	if ($mosConfig_mailfrom != '' && $mosConfig_fromname != '') {
		$adminName2 	= $mosConfig_fromname;
		$adminEmail2 	= $mosConfig_mailfrom;
	} else {
	// use email address and name of first superadmin for use in email sent to user
		$query = "SELECT name, email"
		. "\n FROM #__users"
		. "\n WHERE LOWER( usertype ) = 'superadministrator'"
		. "\n OR LOWER( usertype ) = 'super administrator'"
		;
		$database->setQuery( $query );
		$rows = $database->loadObjectList();
		$row2 			= $rows[0];
		$adminName2 	= $row2->name;
		$adminEmail2 	= $row2->email;
	}
	$where 			= array();

	// exclude any child group id's for this user
	$pgids = $acl->get_group_children( $my->gid, 'ARO', 'RECURSE' );

	if (is_array( $pgids ) && count( $pgids ) > 0) {
		$where[] = "(a.gid NOT IN (" . implode( ',', $pgids ) . "))";
	}

	if ($cb_installed){
		$query = "SELECT a.*, m.reminders, m.lastReminderDate"
				. "\n FROM #__users AS a"
				."\n INNER JOIN #__comprofiler AS c ON a.id = c.id";
		$where[] = " cbactivation <> '' ";
	}else{
		$query = "SELECT a.*,  m.reminders, m.lastReminderDate"
				. "\n FROM #__users AS a";
				$where[] = " activation <> '' ";
	}
	$query .= "\n INNER JOIN #__mcs AS m ON a.id = m.userid";
	$query .= (count( $where ) ? "\n WHERE " . implode( ' AND ', $where ) : "");
	$database->setQuery( $query );
	$rows = $database->loadObjectList();
	foreach( $rows as $row ) {
		if($cb_installed)
			$tagsValues[4] = $mosConfig_live_site."/index.php?option=com_comprofiler&task=confirm&confirmcode=".$row->cbactivation;
		else
			$tagsValues[4] = $mosConfig_live_site."/index.php?option=com_registration&task=activate&activation=".$row->activation;
		$tagsValues[0] = $row->name;
		$tagsValues[1] = $row->username;
		$message = getmcsParam('rae_message');
		$message = str_replace($tags, $tagsValues, $message);
		$message = html_entity_decode($message, ENT_QUOTES);
		// Send email to user
		//mosMail($adminEmail2, $adminName2, $row->email, $subject, $message,0,NULL,$adminEmail2);
		mosMail($adminEmail2, $adminName2, $row->email, $subject, $message);
		updateReminders($row->id);
		$emails_count++;
	}
	if(!$auto)
		mosRedirect( 'index2.php?option=mcs&task=inactive','There are '.$emails_count.' email(s) have been sent' );
}
if(!function_exists("josGetArrayInts"))
{
	function josGetArrayInts( $name, $type=NULL ) {
		if ( $type == NULL ) {
			$type = $_POST;
		}

		$array = mosGetParam( $type, $name, array(0) );

		mosArrayToInts( $array );

		if (!is_array( $array )) {
			$array = array(0);
		}

		return $array;
	}
}
?>
